/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the LocationsList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &LocationsList{}

// LocationsList struct for LocationsList
type LocationsList struct {
	Results []ChannelLocation `json:"results"`
	Total int32 `json:"total"`
}

// NewLocationsList instantiates a new LocationsList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewLocationsList(results []ChannelLocation, total int32) *LocationsList {
	this := LocationsList{}
	this.Results = results
	this.Total = total
	return &this
}

// NewLocationsListWithDefaults instantiates a new LocationsList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewLocationsListWithDefaults() *LocationsList {
	this := LocationsList{}
	return &this
}

// GetResults returns the Results field value
func (o *LocationsList) GetResults() []ChannelLocation {
	if o == nil {
		var ret []ChannelLocation
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *LocationsList) GetResultsOk() ([]ChannelLocation, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *LocationsList) SetResults(v []ChannelLocation) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *LocationsList) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *LocationsList) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *LocationsList) SetTotal(v int32) {
	o.Total = v
}

func (o LocationsList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o LocationsList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableLocationsList struct {
	value *LocationsList
	isSet bool
}

func (v NullableLocationsList) Get() *LocationsList {
	return v.value
}

func (v *NullableLocationsList) Set(val *LocationsList) {
	v.value = val
	v.isSet = true
}

func (v NullableLocationsList) IsSet() bool {
	return v.isSet
}

func (v *NullableLocationsList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableLocationsList(val *LocationsList) *NullableLocationsList {
	return &NullableLocationsList{value: val, isSet: true}
}

func (v NullableLocationsList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableLocationsList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


